<?php

namespace Test123\Test123\Http\Controllers;

use App\Http\Controllers\PublicController as CMSPublicController;
use Test123\Test123\Interfaces\MedicineRepositoryInterface;

class MedicinePublicController extends CMSPublicController
{
    /**
     * Constructor.
     *
     * @param type \Test123\Medicine\Interfaces\MedicineRepositoryInterface $medicine
     *
     * @return type
     */
    public function __construct(MedicineRepositoryInterface $medicine)
    {
        $this->repository = $medicine;
        parent::__construct();
    }

    /**
     * Show medicine's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $medicines = $this->repository->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();

        return $this->theme->of('test123::public.medicine.index', compact('medicines'))->render();
    }

    /**
     * Show medicine.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $medicine = $this->repository->scopeQuery(function($query) use ($slug) {
            return $query->orderBy('id','DESC')
                         ->where('slug', $slug);
        })->first(['*']);

        return $this->theme->of('test123::public.medicine.show', compact('medicine'))->render();
    }
}
